"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var withProps = function withProps(props) {
  return function (fn) {
    var newFn = function newFn() {
      Object.defineProperties(this, Object.getOwnPropertyDescriptors(new fn()));

      if (typeof props === "function") {
        var newProps = props(this);
        Object.defineProperties(this, Object.getOwnPropertyDescriptors(newProps));
      } else {
        Object.defineProperties(this, Object.getOwnPropertyDescriptors(props));
      }
    }; // Make sure to pass static props as well.


    Object.assign(newFn, fn);
    return newFn;
  };
};

var _default = withProps;
exports.default = _default;
//# sourceMappingURL=withProps.js.map